package mc600.gamemanager;

import java.net.*;
/**
 * Insert the type's description here.
 * Creation date: (3/8/00 7:37:40 PM)
 * @author: 
 */
public class Player{
	protected final static String MAGIC    = "Stick Game Player v1.0";

	public 	  final static String STARTCMD = "STRT";	// Lance que indica que o jogador deve iniciar partida
	private String playername;
	public final static int CASTSIZE = 4;			// Tamanho do lance
	protected final static int MINIP = 30000;			// Faixa inicial de enderecos IP
	protected final static int MAXIP = 30099;			// Faixa final para enderecos IP
	public final static int MAXPLAYERNAME = 256;		// Tamanho maximo do nome do jogador

	public final static int MAXRESPONSETIME = 5000;  // Tempo maximo de espera por lance de jogador
	public final static int MAXGAMETIME     = 5000;  // Tempo maximo da partida
														// em milisegundos
	public final static int XDIM = 6;
	public final static int YDIM = 6;
/**
 * Insert the method's description here.
 * Creation date: (3/23/00 12:50:45 AM)
 */
public Player() {}
/**
 * Insert the method's description here.
 * Creation date: (3/8/00 7:38:40 PM)
 * @param ip java.lang.String
 * @param port int
 * @param email java.lang.String
 * @exception java.lang.Exception The exception description.
 */
public Player(String email){
	

	// Salva email como playername
	this.playername = email;
	
	}
// converte o cast xyxy num inteiro, shiftando os bytes....
//     c4      c3        c2       c1
//  00000000 00000000 00000000 00000000
//
public static int castToInt(String cast){
	int c1,c2,c3,c4;
	int icast=0;

	c1 = cast.charAt(0);
	c2 = cast.charAt(1);
	c3 = cast.charAt(2);
	c4 = cast.charAt(3);

	icast = c1;
	icast |= (c2 << 8);
	icast |= (c3 << 16);
	icast |= (c4 << 24);

	return(icast);

}
/**
 * Insert the method's description here.
 * Creation date: (3/23/00 12:51:29 AM)
 * @return java.lang.String
 */
public String getPlayername() {
	return playername;
}
// converte o inteiro em cast, shiftando os bytes
//
//     c4      c3        c2       c1
//  00000000 00000000 00000000 00000000
//
//
public static String intToCast(int icast){

	char c1,c2,c3,c4;
	StringBuffer cast = new StringBuffer(4);

	c1 = (char) (icast & 0xFF);
	c2 = (char) ((icast >> 8)  & 0xFF);
	c3 = (char) ((icast >> 16) & 0xFF);
	c4 = (char) ((icast >> 24) & 0xFF);	


	cast.append(c1);
	cast.append(c2);
	cast.append(c3);
	cast.append(c4);
	
	return (new String(cast.toString()));

}
/**
 * Insert the method's description here.
 * Creation date: (3/23/00 12:51:29 AM)
 * @param newPlayername java.lang.String
 */
protected void setPlayername(String newPlayername) {

	if (newPlayername.length() <= MAXPLAYERNAME)
		playername = newPlayername;
}
}
